/*
 * -----------------------------------------------------------------------
 *
 * NOTE: Do *not* edit this file; instead, edit 'erl_alloc.types' and
 *       build again! This file was automatically generated by
 *       'make_alloc_types' on Thu May  3 16:15:10 2007.
 *
 * -----------------------------------------------------------------------
 *
 * ``The contents of this file are subject to the Erlang Public License,
 * Version 1.1, (the "License"); you may not use this file except in
 * compliance with the License. You should have received a copy of the
 * Erlang Public License along with this software. If not, it can be
 * retrieved via the world wide web at http://www.erlang.org/.
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Original Code is Ericsson Utvecklings AB.
 * Portions created by Ericsson are Copyright 1999, Ericsson Utvecklings
 * AB. All Rights Reserved.''
 */

#ifndef ERL_ALLOC_TYPES_H__
#define ERL_ALLOC_TYPES_H__


/* --- Allocator numbers -------------------------------------------------- */

#define ERTS_ALC_A_INVALID (0)

#define ERTS_ALC_A_MIN (1)

#define ERTS_ALC_A_SYSTEM (1)
#define ERTS_ALC_A_TEMPORARY (2)
#define ERTS_ALC_A_SHORT_LIVED (3)
#define ERTS_ALC_A_STANDARD (4)
#define ERTS_ALC_A_LONG_LIVED (5)
#define ERTS_ALC_A_EHEAP (6)
#define ERTS_ALC_A_BINARY (7)
#define ERTS_ALC_A_ETS (8)
#define ERTS_ALC_A_FIXED_SIZE (9)

#define ERTS_ALC_A_MAX (9)


/* --- Class numbers ------------------------------------------------------ */

#define ERTS_ALC_C_INVALID (0)

#define ERTS_ALC_C_MIN (1)

#define ERTS_ALC_C_PROCESSES  (1)
#define ERTS_ALC_C_ETS  (2)
#define ERTS_ALC_C_BINARIES  (3)
#define ERTS_ALC_C_ATOM  (4)
#define ERTS_ALC_C_SYSTEM  (5)
#define ERTS_ALC_C_CODE  (6)

#define ERTS_ALC_C_MAX (6)


/* --- Type number intervals ---------------------------------------------- */

#define ERTS_ALC_N_INVALID (0)

#define ERTS_ALC_N_MIN (1)

/* Type numbers used for sys_alloc */
#define ERTS_ALC_N_MIN_A_SYSTEM (1)
#define ERTS_ALC_N_MAX_A_SYSTEM (8)

/* Type numbers used for temp_alloc */
#define ERTS_ALC_N_MIN_A_TEMPORARY (9)
#define ERTS_ALC_N_MAX_A_TEMPORARY (23)

/* Type numbers used for sl_alloc */
#define ERTS_ALC_N_MIN_A_SHORT_LIVED (24)
#define ERTS_ALC_N_MAX_A_SHORT_LIVED (30)

/* Type numbers used for std_alloc */
#define ERTS_ALC_N_MIN_A_STANDARD (31)
#define ERTS_ALC_N_MAX_A_STANDARD (56)

/* Type numbers used for ll_alloc */
#define ERTS_ALC_N_MIN_A_LONG_LIVED (57)
#define ERTS_ALC_N_MAX_A_LONG_LIVED (79)

/* Type numbers used for eheap_alloc */
#define ERTS_ALC_N_MIN_A_EHEAP (80)
#define ERTS_ALC_N_MAX_A_EHEAP (82)

/* Type numbers used for binary_alloc */
#define ERTS_ALC_N_MIN_A_BINARY (83)
#define ERTS_ALC_N_MAX_A_BINARY (84)

/* Type numbers used for ets_alloc */
#define ERTS_ALC_N_MIN_A_ETS (85)
#define ERTS_ALC_N_MAX_A_ETS (92)

/* Type numbers used for fix_alloc */
#define ERTS_ALC_N_MIN_A_FIXED_SIZE (93)
#define ERTS_ALC_N_MAX_A_FIXED_SIZE (102)

#define ERTS_ALC_N_MAX (102)


/* --- Multi thread use of allocators -------------------------------------- */

#define ERTS_ALC_MTA_SYSTEM (1)
#define ERTS_ALC_MTA_TEMPORARY (0)
#define ERTS_ALC_MTA_SHORT_LIVED (0)
#define ERTS_ALC_MTA_STANDARD (0)
#define ERTS_ALC_MTA_LONG_LIVED (0)
#define ERTS_ALC_MTA_EHEAP (0)
#define ERTS_ALC_MTA_BINARY (0)
#define ERTS_ALC_MTA_ETS (0)
#define ERTS_ALC_MTA_FIXED_SIZE (0)


/* --- Types --------------------------------------------------------------- */

typedef Uint32 ErtsAlcType_t; /* The type used for memory types */

#define ERTS_ALC_T_INVALID (0)

#define ERTS_ALC_T_UNDEF (209)
#define ERTS_ALC_T_DRV (337)
#define ERTS_ALC_T_NBIF_TABLE (465)
#define ERTS_ALC_T_ASYNC (593)
#define ERTS_ALC_T_INFO_DSBUF (721)
#define ERTS_ALC_T_ETHR_INTERNAL (849)
#define ERTS_ALC_T_ENVIRONMENT (977)
#define ERTS_ALC_T_PUTENV_STR (1105)
#define ERTS_ALC_T_MSG_ROOTS (1170)
#define ERTS_ALC_T_ROOTSET (1298)
#define ERTS_ALC_T_LOADER_TMP (1506)
#define ERTS_ALC_T_NC_TMP (1618)
#define ERTS_ALC_T_TMP (1746)
#define ERTS_ALC_T_DCTRL_BUF (1874)
#define ERTS_ALC_T_TMP_DIST_BUF (2002)
#define ERTS_ALC_T_ESTACK (2130)
#define ERTS_ALC_T_DB_TMP (2210)
#define ERTS_ALC_T_DB_MC_STK (2338)
#define ERTS_ALC_T_DB_MS_CMPL_HEAP (2466)
#define ERTS_ALC_T_LOGGER_DSBUF (2642)
#define ERTS_ALC_T_TMP_DSBUF (2770)
#define ERTS_ALC_T_DDLL_TMP_BUF (2898)
#define ERTS_ALC_T_SYS_READ_BUF (3026)
#define ERTS_ALC_T_MSG_REF (3091)
#define ERTS_ALC_T_SL_BIF_TIMER (3219)
#define ERTS_ALC_T_DB_FIXATION (3363)
#define ERTS_ALC_T_DB_FIX_DEL (3491)
#define ERTS_ALC_T_DB_MS_RUN_HEAP (3619)
#define ERTS_ALC_T_FD_LIST (3795)
#define ERTS_ALC_T_POLLSET_UPDREQ (3923)
#define ERTS_ALC_T_LINK_LH (3988)
#define ERTS_ALC_T_MONITOR_LH (4116)
#define ERTS_ALC_T_NLINK_LH (4244)
#define ERTS_ALC_T_LL_BIF_TIMER (4372)
#define ERTS_ALC_T_REG_TABLE (4564)
#define ERTS_ALC_T_FUN_TABLE (4708)
#define ERTS_ALC_T_DIST_TABLE (4820)
#define ERTS_ALC_T_NODE_TABLE (4948)
#define ERTS_ALC_T_MODULE_REFS (5092)
#define ERTS_ALC_T_DCACHE (5204)
#define ERTS_ALC_T_DIST_ENTRY (5332)
#define ERTS_ALC_T_NODE_ENTRY (5460)
#define ERTS_ALC_T_DRV_ENTRY_LIST (5588)
#define ERTS_ALC_T_ARG_REG (5652)
#define ERTS_ALC_T_PROC_DICT (5780)
#define ERTS_ALC_T_CALLS_BUF (5908)
#define ERTS_ALC_T_BPD (6100)
#define ERTS_ALC_T_PORT_NAME (6228)
#define ERTS_ALC_T_LINEBUF (6356)
#define ERTS_ALC_T_IOQ (6484)
#define ERTS_ALC_T_BITS_BUF (6612)
#define ERTS_ALC_T_PORT_CALL_BUF (6740)
#define ERTS_ALC_T_DDLL_PROCESS (6868)
#define ERTS_ALC_T_DDLL_HANDLE (6996)
#define ERTS_ALC_T_FD_ENTRY_BUF (7124)
#define ERTS_ALC_T_DRV_EV_D_STATE (7252)
#define ERTS_ALC_T_ATOM_TXT (7365)
#define ERTS_ALC_T_BIF_TIMER_TABLE (7509)
#define ERTS_ALC_T_ATOM_TABLE (7621)
#define ERTS_ALC_T_EXPORT_TABLE (7781)
#define ERTS_ALC_T_MODULE_TABLE (7909)
#define ERTS_ALC_T_PROC_TABLE (7957)
#define ERTS_ALC_T_PORT_TABLE (8149)
#define ERTS_ALC_T_TIMER_WHEEL (8277)
#define ERTS_ALC_T_CODE (8421)
#define ERTS_ALC_T_ASYNC_Q (8533)
#define ERTS_ALC_T_DB_TABLES (8613)
#define ERTS_ALC_T_DB_MS_PSDO_PROC (8741)
#define ERTS_ALC_T_INSTR_INFO (8917)
#define ERTS_ALC_T_SCHDLR_DATA (8981)
#define ERTS_ALC_T_DDLL_ERRCODES (9173)
#define ERTS_ALC_T_DRV_TAB (9301)
#define ERTS_ALC_T_FD_TAB (9429)
#define ERTS_ALC_T_CS_PROG_PATH (9557)
#define ERTS_ALC_T_POLLSET (9685)
#define ERTS_ALC_T_POLL_FDS (9813)
#define ERTS_ALC_T_POLL_RES_EVS (9941)
#define ERTS_ALC_T_FD_STATUS (10069)
#define ERTS_ALC_T_DRV_EV_STATE (10197)
#define ERTS_ALC_T_HEAP (10262)
#define ERTS_ALC_T_OLD_HEAP (10390)
#define ERTS_ALC_T_HEAP_FRAG (10518)
#define ERTS_ALC_T_DRV_BINARY (10679)
#define ERTS_ALC_T_BINARY (10807)
#define ERTS_ALC_T_DB_SEG (10920)
#define ERTS_ALC_T_DB_SEG_TAB (11048)
#define ERTS_ALC_T_DB_STK (11176)
#define ERTS_ALC_T_DB_TRANS_TAB (11304)
#define ERTS_ALC_T_DB_SEL_LIST (11432)
#define ERTS_ALC_T_DB_DMC_ERROR (11560)
#define ERTS_ALC_T_DB_DMC_ERR_INFO (11688)
#define ERTS_ALC_T_DB_TERM (11816)
#define ERTS_ALC_T_PROC (11929)
#define ERTS_ALC_T_ATOM (12105)
#define ERTS_ALC_T_EXPORT (12265)
#define ERTS_ALC_T_MODULE (12393)
#define ERTS_ALC_T_REG_PROC (12441)
#define ERTS_ALC_T_MONITOR_SH (12569)
#define ERTS_ALC_T_NLINK_SH (12697)
#define ERTS_ALC_T_PROC_LIST (12825)
#define ERTS_ALC_T_FUN_ENTRY (13033)
#define ERTS_ALC_T_DB_TABLE (13097)


/* --- Field sizes, masks, and shifts -------------------------------------- */

#define ERTS_ALC_A_BITS (4)
#define ERTS_ALC_C_BITS (3)
#define ERTS_ALC_N_BITS (7)
#define ERTS_ALC_T_BITS (14)

#define ERTS_ALC_A_MASK (15)
#define ERTS_ALC_C_MASK (7)
#define ERTS_ALC_N_MASK (127)
#define ERTS_ALC_T_MASK (16383)

#define ERTS_ALC_A_SHIFT (0)
#define ERTS_ALC_C_SHIFT (4)
#define ERTS_ALC_N_SHIFT (7)


/* --- Mappings ------------------------------------------------------------ */

/* type -> type number */
#define ERTS_ALC_T2N(T) (((T) >> ERTS_ALC_N_SHIFT) & ERTS_ALC_N_MASK)

/* type -> allocator number */
#define ERTS_ALC_T2A(T) (((T) >> ERTS_ALC_A_SHIFT) & ERTS_ALC_A_MASK)

/* type -> class number */
#define ERTS_ALC_T2C(T) (((T) >> ERTS_ALC_C_SHIFT) & ERTS_ALC_C_MASK)

/* type number -> type */
#define ERTS_ALC_N2T(N) (erts_alc_n2t[(N)])

/* type number -> type description */
#define ERTS_ALC_N2TD(N) (erts_alc_n2td[(N)])

/* type -> type description */
#define ERTS_ALC_T2TD(T) (ERTS_ALC_N2TD(ERTS_ALC_T2N((T))))

/* class number -> class description */
#define ERTS_ALC_C2CD(C) (erts_alc_c2cd[(C)])

/* allocator number -> allocator description */
#define ERTS_ALC_A2AD(A) (erts_alc_a2ad[(A)])

extern const ErtsAlcType_t erts_alc_n2t[];
extern const char *erts_alc_n2td[];
extern const char *erts_alc_c2cd[];
extern const char *erts_alc_a2ad[];

#ifdef ERTS_ALC_INTERNAL__

const ErtsAlcType_t erts_alc_n2t[] = {
  ERTS_ALC_T_INVALID,
  ERTS_ALC_T_UNDEF,
  ERTS_ALC_T_DRV,
  ERTS_ALC_T_NBIF_TABLE,
  ERTS_ALC_T_ASYNC,
  ERTS_ALC_T_INFO_DSBUF,
  ERTS_ALC_T_ETHR_INTERNAL,
  ERTS_ALC_T_ENVIRONMENT,
  ERTS_ALC_T_PUTENV_STR,
  ERTS_ALC_T_MSG_ROOTS,
  ERTS_ALC_T_ROOTSET,
  ERTS_ALC_T_LOADER_TMP,
  ERTS_ALC_T_NC_TMP,
  ERTS_ALC_T_TMP,
  ERTS_ALC_T_DCTRL_BUF,
  ERTS_ALC_T_TMP_DIST_BUF,
  ERTS_ALC_T_ESTACK,
  ERTS_ALC_T_DB_TMP,
  ERTS_ALC_T_DB_MC_STK,
  ERTS_ALC_T_DB_MS_CMPL_HEAP,
  ERTS_ALC_T_LOGGER_DSBUF,
  ERTS_ALC_T_TMP_DSBUF,
  ERTS_ALC_T_DDLL_TMP_BUF,
  ERTS_ALC_T_SYS_READ_BUF,
  ERTS_ALC_T_MSG_REF,
  ERTS_ALC_T_SL_BIF_TIMER,
  ERTS_ALC_T_DB_FIXATION,
  ERTS_ALC_T_DB_FIX_DEL,
  ERTS_ALC_T_DB_MS_RUN_HEAP,
  ERTS_ALC_T_FD_LIST,
  ERTS_ALC_T_POLLSET_UPDREQ,
  ERTS_ALC_T_LINK_LH,
  ERTS_ALC_T_MONITOR_LH,
  ERTS_ALC_T_NLINK_LH,
  ERTS_ALC_T_LL_BIF_TIMER,
  ERTS_ALC_T_REG_TABLE,
  ERTS_ALC_T_FUN_TABLE,
  ERTS_ALC_T_DIST_TABLE,
  ERTS_ALC_T_NODE_TABLE,
  ERTS_ALC_T_MODULE_REFS,
  ERTS_ALC_T_DCACHE,
  ERTS_ALC_T_DIST_ENTRY,
  ERTS_ALC_T_NODE_ENTRY,
  ERTS_ALC_T_DRV_ENTRY_LIST,
  ERTS_ALC_T_ARG_REG,
  ERTS_ALC_T_PROC_DICT,
  ERTS_ALC_T_CALLS_BUF,
  ERTS_ALC_T_BPD,
  ERTS_ALC_T_PORT_NAME,
  ERTS_ALC_T_LINEBUF,
  ERTS_ALC_T_IOQ,
  ERTS_ALC_T_BITS_BUF,
  ERTS_ALC_T_PORT_CALL_BUF,
  ERTS_ALC_T_DDLL_PROCESS,
  ERTS_ALC_T_DDLL_HANDLE,
  ERTS_ALC_T_FD_ENTRY_BUF,
  ERTS_ALC_T_DRV_EV_D_STATE,
  ERTS_ALC_T_ATOM_TXT,
  ERTS_ALC_T_BIF_TIMER_TABLE,
  ERTS_ALC_T_ATOM_TABLE,
  ERTS_ALC_T_EXPORT_TABLE,
  ERTS_ALC_T_MODULE_TABLE,
  ERTS_ALC_T_PROC_TABLE,
  ERTS_ALC_T_PORT_TABLE,
  ERTS_ALC_T_TIMER_WHEEL,
  ERTS_ALC_T_CODE,
  ERTS_ALC_T_ASYNC_Q,
  ERTS_ALC_T_DB_TABLES,
  ERTS_ALC_T_DB_MS_PSDO_PROC,
  ERTS_ALC_T_INSTR_INFO,
  ERTS_ALC_T_SCHDLR_DATA,
  ERTS_ALC_T_DDLL_ERRCODES,
  ERTS_ALC_T_DRV_TAB,
  ERTS_ALC_T_FD_TAB,
  ERTS_ALC_T_CS_PROG_PATH,
  ERTS_ALC_T_POLLSET,
  ERTS_ALC_T_POLL_FDS,
  ERTS_ALC_T_POLL_RES_EVS,
  ERTS_ALC_T_FD_STATUS,
  ERTS_ALC_T_DRV_EV_STATE,
  ERTS_ALC_T_HEAP,
  ERTS_ALC_T_OLD_HEAP,
  ERTS_ALC_T_HEAP_FRAG,
  ERTS_ALC_T_DRV_BINARY,
  ERTS_ALC_T_BINARY,
  ERTS_ALC_T_DB_SEG,
  ERTS_ALC_T_DB_SEG_TAB,
  ERTS_ALC_T_DB_STK,
  ERTS_ALC_T_DB_TRANS_TAB,
  ERTS_ALC_T_DB_SEL_LIST,
  ERTS_ALC_T_DB_DMC_ERROR,
  ERTS_ALC_T_DB_DMC_ERR_INFO,
  ERTS_ALC_T_DB_TERM,
  ERTS_ALC_T_PROC,
  ERTS_ALC_T_ATOM,
  ERTS_ALC_T_EXPORT,
  ERTS_ALC_T_MODULE,
  ERTS_ALC_T_REG_PROC,
  ERTS_ALC_T_MONITOR_SH,
  ERTS_ALC_T_NLINK_SH,
  ERTS_ALC_T_PROC_LIST,
  ERTS_ALC_T_FUN_ENTRY,
  ERTS_ALC_T_DB_TABLE,
  ERTS_ALC_T_INVALID
};

const char *erts_alc_n2td[] = {
  "invalid_type",
  "undefined",
  "drv_internal",
  "nbif_tab",
  "async",
  "info_dsbuf",
  "ethread_internal",
  "environment",
  "putenv_string",
  "msg_roots",
  "root_set",
  "loader_tmp",
  "nc_tmp",
  "tmp",
  "dctrl_buf",
  "tmp_dist_buf",
  "estack",
  "db_tmp",
  "db_mc_stack",
  "db_match_spec_cmpl_heap",
  "logger_dsbuf",
  "tmp_dsbuf",
  "ddll_tmp_buf",
  "sys_read_buf",
  "msg_ref",
  "bif_timer_sl",
  "db_fixation",
  "fixed_del",
  "db_match_spec_run_heap",
  "fd_list",
  "pollset_update_req",
  "link_lh",
  "monitor_lh",
  "nlink_lh",
  "bif_timer_ll",
  "reg_tab",
  "fun_tab",
  "dist_tab",
  "node_tab",
  "module_refs",
  "dcache",
  "dist_entry",
  "node_entry",
  "drv_entry_list",
  "arg_reg",
  "proc_dict",
  "calls_buf",
  "bpd",
  "port_name",
  "line_buf",
  "io_queue",
  "bits_buf",
  "port_call_buf",
  "ddll_processes",
  "ddll_handle",
  "fd_entry_buf",
  "driver_event_data_state",
  "atom_text",
  "bif_timer_table",
  "atom_tab",
  "export_tab",
  "module_tab",
  "proc_tab",
  "port_tab",
  "timer_wheel",
  "code",
  "async_queue",
  "db_tabs",
  "db_match_pseudo_proc",
  "instr_info",
  "scheduler_data",
  "ddll_errcodes",
  "drv_tab",
  "fd_tab",
  "cs_prog_path",
  "poll_set",
  "poll_fds",
  "poll_result_events",
  "fd_status",
  "driver_event_state",
  "heap",
  "old_heap",
  "heap_frag",
  "drv_binary",
  "binary",
  "db_segment",
  "db_segment_tab",
  "db_stack",
  "db_trans_tab",
  "db_select_list",
  "db_dmc_error",
  "db_dmc_error_info",
  "db_term",
  "proc",
  "atom_entry",
  "export_entry",
  "module_entry",
  "reg_proc",
  "monitor_sh",
  "nlink_sh",
  "proc_list",
  "fun_entry",
  "db_tab",
  NULL
};

const char *erts_alc_c2cd[] = {
  "invalid_class",
  "process_data",
  "ets_data",
  "binary_data",
  "atom_data",
  "system_data",
  "code_data",
  NULL
};

const char *erts_alc_a2ad[] = {
  "invalid_allocator",
  "sys_alloc",
  "temp_alloc",
  "sl_alloc",
  "std_alloc",
  "ll_alloc",
  "eheap_alloc",
  "binary_alloc",
  "ets_alloc",
  "fix_alloc",
  NULL
};

#endif /* #ifdef ERTS_ALC_INTERNAL__ */


/* ------------------------------------------------------------------------- */
#endif /* #ifndef ERL_ALLOC_TYPES_H__ */
